#include <iostream>
#include <vector>
#include <cstdlib>
using namespace std;
int n, m, q;
int cap[128][128];
int cf[128][128];


void addEdge ( int x, int y ) {

    cap[x][y] ++;
    cap[y][x] ++;
}

int ansF = 0;
int used[128], usedTst;

bool getF ( int x ) {
    if ( x == n ) { return 1; }
    if ( used[x] == usedTst ) { return 0; }
    used[x] = usedTst;
//    cout << "reached "<< x << "  "<< cf << "\n";

    for ( int i = n ; i >= 1 ; i -- ) {
        if ( cap[x][i] > cf[x][i] ) {

            int nf = getF ( i );
            if ( nf ) {

                cf[x][i] ++;
                cf[i][x] --;
                return 1;
            }
        }
    }
    return 0;
}

int main () {

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;

    for ( int i = 0 ; i < m ; i ++ ) {
        int a, b;
        cin >> a >> b;
        addEdge ( a, b );
    }
    while ( 1 ) {
        usedTst ++;
        int cf = getF( 1 ) ;
        ansF += cf;
//        cout << "+cf\n";
        if ( cf == 0 ) { break; }
    }
    cout << ansF << "\n";
    cin >> q;
    srand( 420420 );

    for ( int i = 0 ; i < q ; i ++ ) {
        int a, b;
        cin >> a >> b;
        addEdge ( a, b );

        //if ( i >= 4000 && i +4000 < q && ch == 0 ) { cout << ansF << "\n"; continue; }

        if ( used[a] != usedTst && used[b] != usedTst ) {
//            cout << ansF << "\n";
//            continue;
        }

        while ( 1 ) {
            usedTst ++;
            int cff = getF( 1 ) ;
            ansF += cff;
    //        cout << "+cf\n";
            if ( cff == 0 ) { break; }
        }

        cout << ansF << "\n";
    }
    return 0;
}
/*5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5


5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5


5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5

*/
