#include <iostream>
#include "xbgame.h"
using namespace std;
int N;
int moves = 0, firstC, dir; //0 for left 1 for right
bool table[101][101];
int lr, lc;
void update(int r, int c)
{
    if(lr == 0)
    {
        table[r][c] = 1;
        lr = r;
        lc = c;
        return;
    }
    for(int i = min(r, lr); i <= max(r, lr); i ++) table[i][c] = 1;
    for(int i = min(c, lc); i <= max(c, lc); i ++) table[r][i] = 1;
    lr = r;
    lc = c;
}
void mv(int &R, int &C, int d)
{
    //cout << "Moving " << d << " from " << R << " " << C << endl;
    if(d)
    {
        while(C < N)
        {
            if(table[R][C+1]) break;
            else C ++;
        }
    }
    else
    {
        while(C > 1)
        {
            if(table[R][C-1]) break;
            else C --;
        }
    }
   // cout << "Reached " << R << " " << C << endl;
}
void play(int &R, int &C)
{
    xbgame(N, R, C);
    update(R, C);
    if(moves == 0)
    {
        firstC = C;
        moves ++;
        if(C <= N/2)
        {
            dir = 1;
            C = N;
        }
        else C = 0;
        update(R, C);
        return;
    }
    if(dir)
    {
        if((C == firstC || table[R][C-1]) && C!=N)
        {
            mv(R, C, 1);
        }
        else
        {
            mv(R, C, 0);
        }
        if(C < firstC) C = firstC;
    }
    else
    {
        if((C == firstC || table[R][C+1]) && C != 1)
        {
            mv(R, C, 0);
        }
        else
        {
            mv(R, C, 1);
        }
        if(C > firstC) C= firstC;
    }
    update(R, C);
}
