#include <iostream>
#include <cmath>
using namespace std;
int p[100001];
int posp[100001];
int posq[100001];
int q[100001];
int previ[100001];
int nxt[100001];
int kprev[100001];
int knxt[100001];
int n, k;
void updatek(int w)
{
    int curr = nxt[w];
    for(int i = 0; i < k; i ++)
    {
        knxt[w] = curr;
        curr = nxt[curr];
    }
    curr = previ[w];
    for(int i = 0; i < k; i ++)
    {
        kprev[w] = curr;
        curr = previ[curr];
    }
}
void mv(int a, int b, int c, int d)
{
    //cout << "swapping " << a << "," << b << " " << c << ", " << d << endl;
    int e = previ[a];
    int f = nxt[d];
    //cout << a << " " << b << " " << c << " " << d << " " << e << " " << f << endl;
    previ[c] = e;
    previ[a] = d;
    nxt[d] = a;
    nxt[b] = f;
    nxt[e] = c;
    previ[f] = b;
    updatek(a);
    updatek(b);
    updatek(c);
    updatek(d);
    updatek(e);
    updatek(f);
    //cout << nxt[0] << endl;
}
void swp(int wh, int curr)
{
    while(nxt[curr] != wh && previ[wh] != curr)
    {
        mv(kprev[wh],previ[wh],wh,previ[knxt[wh]]);
        int a;
        //cin >> a;
        //cout << nxt[0] << "aa"<<endl;
    }
}
int main()
{
    cin >> n >> k;
    for(int i = 0; i < n; i ++)
    {
        cin >> p[i];
        posp[p[i]] = i;
    }
    for(int i = 0; i < n; i ++)
    {
        cin >> q[i];
        posq[q[i]] = i;
    }
    for(int i = 0; i < n; i ++)
    {
        if(i > 0) previ[q[i]] = q[i-1];
        if(i < n-1) nxt[q[i]] = q[i+1];
        if(i >= k) kprev[q[i]] = q[i-k];
        if(i < n-k) knxt[q[i]] = q[i+k];
    }
    nxt[0] = q[0];
    previ[0] = q[n-1];
    previ[q[0]] = 0;
    nxt[q[n-1]] = 0;
    for(int i = 1; i <= n; i ++)
    {
        if(int(abs(posp[i]-posq[i]))%k)
        {
            cout << 0 << endl;
            return 0;
        }
    }
    for(int i = 0; i < n-2*k+1; i ++)
    {
        if(i>0) swp(p[i],p[i-1]);
        else swp(p[i],0);
    }
    int curr = nxt[0];
    for(int i = 0; i < n && curr != 0; i ++)
    {
        if(p[i] != curr)
        {
            cout << 0 << endl;
            return 0;
        }
        curr = nxt[curr];
    }
    cout << 1 << endl;
    //start off q[0] then nxt[p[0]]
}
