#include "xbgame.h"
#include <iostream>

int posx, posy, _n;
bool _first = true;
int _prevpx, _prevpy;

bool field[100][100];

/*
void score(int fy, int fx, int x, int y) {
	bool cp[100][100];
	for(int i = 0;i < 100;i ++) { for(int j = 0;j < 100;j ++) { cp[i][j] = field[i][j]; }}

		int mx = std::min(_prevpx, posx);
		int bx = std::max(_prevpx, posx);
		for(int x = mx;x <= bx;x ++) field[x][posy] = true;

		int my = std::min(_prevpy, posy);
		int by = std::max(_prevpy, posy);
		for(int y = my;y <= by;y ++) field[posx][y] = true;
}
*/

void play(int &R, int &C) {
	xbgame(_n, posy, posx);
	if(_first) {
		_first = false;
		R = C = 0;
		return;
	}
	posx --;
	posy --;

	//std::cout << "WTF pl " << posx << ' ' << posy << ' ' << _prevpx << ' ' << _prevpy << std::endl;

	if(!_first) {
		int mx = std::min(_prevpx, posx);
		int bx = std::max(_prevpx, posx);
		for(int x = mx;x <= bx;x ++) field[x][posy] = true;

		int my = std::min(_prevpy, posy);
		int by = std::max(_prevpy, posy);
		for(int y = my;y <= by;y ++) field[posx][y] = true;
	}

	/*
	for(int i = 0;i < _n;i ++){
		for(int j=0;j<_n;j++){
			std::cout<<field[j][i];
		}
		std::cout <<std::endl;
	}
	*/

	int npy = -10, npx = posx;

	int bestd = 1 << 30;
	for(int i = posy + 1;i < _n;i ++) {
		if(field[posx][i]) break;
		int d = 0;
		for(int j = posx;j < _n;j ++) {
			if(field[j][i]) break;
			d ++;
		}
		for(int j = posx-1;j >= 0;j --) {
			if(field[j][i]) break;
			d ++;
		}
		if(d <= bestd) { // TODO other way around?
			bestd = d;
			npy = i;
		}
	}

	for(int i = posy - 1;i >= 0;i --) {
		if(field[posx][i]) break;
		int d = 0;
		for(int j = posx;j < _n;j ++) {
			if(field[j][i]) break;
			d ++;
		}
		for(int j = posx-1;j >= 0;j --) {
			if(field[j][i]) break;
			d ++;
		}
		if(d <= bestd) { // TODO other way around?
			bestd = d;
			npy = i;
		}
	}

	R = npy + 1;
	C = npx + 1;

	_prevpx = posx;
	_prevpy = posy;

	posx = npx;
	posy = npy;

	_first = false;
	if(!_first) {
		int mx = std::min(_prevpx, posx);
		int bx = std::max(_prevpx, posx);
		for(int x = mx;x <= bx;x ++) field[x][posy] = true;

		int my = std::min(_prevpy, posy);
		int by = std::max(_prevpy, posy);
		for(int y = my;y <= by;y ++) field[posx][y] = true;
	}
	/*
	std::cout << "HERE " << posx << ' ' << posy << ' ' << _prevpx << ' ' << _prevpy << std::endl;
	for(int i = 0;i < _n;i ++){
		for(int j=0;j<_n;j++){
			std::cout<<field[j][i];
		}
		std::cout <<std::endl;
	}
	*/

	_prevpx = posx;
	_prevpy = posy;
}
