# include <cstdio>
# include <ctime>
# include <vector>

using namespace std;

const int MAX_N = 1e5 + 10;

int n, k;
int p[MAX_N], q;
int f[MAX_N];

bool greedy1 (vector <int> c)
{
	int i, j, t, l, r, from, to;

	l = 0;
	r = n - 1;
	
	for (i = 0; i < n; i ++)
	{
		if ((double)clock () > (double) 0.17 * CLOCKS_PER_SEC)
			return true;
		if (!(i & 1))
		{
			for (j = 0; j < n; j ++)
				if (c[j] == l)
					break;
			if (j == l)
			{
				l ++;
				continue;
			}
			
			if (j + k - 1 > r)
			{
				to = r;
				from = to - k + 1;
				if (from - k < l)
					return false;
				for (j = from; j <= to; j ++)
					swap (c[j - k], c[j]);
			}
			else
			{
				to = j + k - 1;
				for (; j <= to; j ++)
					swap (c[j - k], c[j]);
			}
			
			i --;
		}
		else
		{
			for (j = 0; j < n; j ++)
				if (c[j] == r)
					break;
			
			if (j == r)
			{
				r --;
				continue;
			}
			
			if (j - k + 1 < l)
			{
				from = l;
				to = from + k - 1;
				if (to + k > r)
					return false;
					
				for (j = from; j <= to; j ++)
					swap (c[j + k], c[j]);
				
			}
			else
			{
				to = j - k + 1;
				for (; j >= to; j --)
					swap (c[j + k], c[j]);
			}
			
			i --;
		}
	}
	
	return true;	
}

int main ()
{
	int i, j;
	scanf ("%d%d", &n, &k);
	
	for (i = 1; i <= n; i ++)
	{
		scanf ("%d", &p[i]);
		f[p[i]] = i;
	}
	
	for (i = 1; i <= n; i ++)
	{
		scanf ("%d", &q);
		p[f[q] - 1] = i - 1;
	}
	
	/**
	for (i = 1; i <= n; i ++)
		printf ("%d ", p[i]);
	printf ("\n");
	**/
	
	for (i = 0; i < n; i ++)
		if ((p[i] % k) != (i % k))
		{
			printf ("0\n");
			return 0;
		}
	
	vector <int> t;
	
	for (i = 0; i < n; i ++)
		t.push_back (p[i]);
	
	if (greedy1 (t))
		printf ("1\n");
	else
		printf ("0\n");
	
	return 0;
}


