#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
using namespace std;
int ans=0;
vector<pair<int,int>> d;

void dist(int start, vector<vector<int>>& v, int& n)
{
    queue<int> q;
    q.push(start);
    vector<bool> used;
    used.resize(n+1);
    used[start]=true;
    d[start]={0, start};
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        for(int j=1;j<=n;j++)
        {
            if(v[x][j]!=0 && !used[j])
            {
                d[j]={d[x].first+1, j};
                used[j]=true;
                q.push(j);
            }
        }
    }
}

void dfs(int cur, vector<vector<int>>& b, int& n)
{
    if(cur==n)
    {
        ans++;
        return;
    }
    for(int i=n; i>=1; i--)
    {
        int c=d[i].second;
        if(b[cur][c]!=0)
        {
            b[cur][c]--;
            b[c][cur]--;
            dfs(c, b, n);
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m,q;
    vector<vector<int>> a;
    vector<vector<int>> copy;
    cin>>n>>m;
    a.resize(n+1, vector<int>(n+1));
    copy.resize(n+1, vector<int>(n+1));
    for(int i=1;i<=m;i++)
    {
        int x,y;
        cin>>x>>y;
        a[x][y]++;
        a[y][x]++;
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            copy[i][j]=a[i][j];
        }
    }

    d.resize(n+1);

    dist(n, a, n);
    sort(d.begin(), d.end());

    dfs(1, copy, n);
    cout<<ans<<endl;
    ans=0;
    cin>>q;
    for(int k=1;k<=q;k++)
    {
        int x,y;
        cin>>x>>y;
        a[x][y]++;
        a[y][x]++;
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                copy[i][j]=a[i][j];
            }
        }
        dfs(1, copy, n);
        cout<<ans<<endl;
        ans=0;
    }

    return 0;
}
/*
5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5
*/
