#include "xbgame.h"
#include <vector>
#include <iostream>

#define random(x) (rand() % x)
#define rnd(lo,hi) ((lo) + (random(((hi)-(lo)+1))))

using namespace std;

int N,Row,Col;
bool Start=true;
bool T[102][102];
bool H=true;

void initT()
{for (int i=1;i<=N;i++)
  for (int j=1;j<=N;j++) T[i][j]=false;
 for (int i=0;i<=N+1;i++)
 {T[0][i]=true;
  T[N+1][i]=true;
  T[i][0]=true;
  T[i][N+1]=true;
 }
 T[Row][Col]=true;
}

void makeMove(int R,int C,bool H)
{T[Row][Col]=true;
 if (H)
 {int st=(Col<C?-1:1);
  for (int i=C;i!=Col;i+=st) T[Row][i]=true;
 }
 else
 {int st=(Row<R?-1:1);
  for (int i=R;i!=Row;i+=st) T[i][Col]=true;
 }
 Row=R;Col=C;
}

void getMove(int &R, int &C)
{vector<int> a;
 if (H)
 {for(int i=Col+1;!T[Row][i];i++) {
 	//if ( T[ Row ][ i + 1 ] == true ){
	 	a.push_back(i);break;
	 //}
 }
  for(int i=Col-1;!T[Row][i];i--) {
  	//if ( T[ Row ][ i - 1 ] == true ) { 
	  	a.push_back(i);break;
	  	//}
	  }
  R=Row;C=a[rnd(0,a.size()-1)];
  if ( a.size ( ) == 2 ) {
  	if ( a[ 0 ] - Col >= Col - a[ 1 ] ) { C = a[ 1 ] ; }
  	else { C = a[ 0 ] ; }
  }
 }
 else
 {for (int i=Row+1;!T[i][Col];i++) {
 	//if ( T[ i + 1 ][ Col ] == true ) { 
 		a.push_back(i);break;
	//}
 	}
  for (int i=Row-1;!T[i][Col];i--) {
  	//if ( T[ i - 1 ][ Col ] == true ) { 
	  	a.push_back(i);break;
	 //}
  }
  R=a[rnd(0,a.size()-1)];C=Col;
  if ( a.size ( ) == 2 ) {
  	if ( a[ 0 ] - Row >= Row - a[ 1 ] ) { R = a[ 1 ] ; }
  	else { R = a[ 0 ] ; }
  }  
 }
}

void play(int &R,int &C)
{
srand(69);
 xbgame(N,R,C);
 if (Start)
 {Row=R;Col=C;
  initT();
  Start=false;
  /**
  if (rnd(0,1))
  {R=C=0;
   H=false;
   return;//skip first move
  }
  **/
  getMove(R,C);
  makeMove(R,C,H);
  return;
 }
 makeMove(R,C,!H);//executing opponent's move
 getMove(R,C);//get next move
 makeMove(R,C,H);//execute the move
}

