#include<iostream>
#include<stdio.h>
#include<cstdlib>
using namespace std ;

#define MAXN 100007

int n , k ;
int a[ MAXN ] ;
int b[ MAXN ] ;

int pos1[ MAXN ] ;
int pos2[ MAXN ] ;

class Tree {
	public :
	int tr[ 5 * MAXN ] ;
	void init ( int where , int IL , int IR ) {
		tr[ where ] = 0 ;
		if ( IL == IR ) { return ; }
		int mid = ( IL + IR ) / 2 ;
		init ( 2 * where , IL , mid ) ;
		init ( 2 * where + 1 , mid + 1 , IR ) ;
	}
	void update ( int where , int IL , int IR , int pos , int val ) {
		if ( IR < pos || pos < IL ) { return ; }
		if ( IL == IR ) {
			tr[ where ] += val ;
			return ;
		}
		int mid = ( IL + IR ) / 2 ;
		if ( pos <= mid ) {
			update ( 2 * where , IL , mid , pos , val ) ;
		}
		else {
			update ( 2 * where + 1 , mid + 1 , IR , pos , val ) ;
		}
		tr[ where ] = ( tr[ 2 * where ] + tr[ 2 * where + 1 ] ) ;
	}
	int query ( int where , int IL , int IR , int CURL , int CURR ) {
		if ( IR < CURL || CURR < IL ) { return 0 ; }
		if ( CURL <= IL && IR <= CURR ) { return tr[ where ] ; }
		int mid = ( IL + IR ) / 2 ;
		return ( query ( 2 * where , IL , mid , CURL , CURR ) + query ( 2 * where + 1 , mid + 1 , IR , CURL , CURR ) ) ;
	}
};
Tree w ;


void check ( ) {
	int i ;
	for ( i = 1 ; i <= n ; i ++ ) {
		if ( a[ i ] != b[ i ] ) { break ; }
	}
	if ( i == ( n + 1 ) ) { printf ( "1\n" ) ; return ; }
	for ( i = 1 ; i <= ( n / 2 ) ; i ++ ) {
		swap ( a[ i ] , a[ i + ( n / 2 ) ] ) ;
	}
	for ( i = 1 ; i <= n ; i ++ ) {
		if ( a[ i ] != b[ i ] ) { break ; }
	}
	if ( i == ( n + 1 ) ) { printf ( "1\n" ) ; return ; }
	printf ( "0\n" ) ; 	
}

void input ( ) {
	scanf ( "%d%d" , &n , &k ) ;
	int i ;
	for ( i = 1 ; i <= n ; i ++ ) {
		scanf ( "%d" , &a[ i ] ) ;
		pos1[ a[ i ] ] = i ;
	}
	for ( i = 1 ; i <= n ; i ++ ) {
		scanf ( "%d" , &b[ i ] ) ;
		pos2[ b[ i ] ] = i ;
	}
}

void solve ( ) {
	if ( n == ( 2 * k ) ) { check ( ) ; return ; }
	///if ( ( k % 2 ) == 1 ) { printf ( "1\n" ) ; return ; }
	long long aux1 , aux2 ;
	aux1 = aux2 = 0 ;
	int i ;
	if ( ( k % 2 ) == 0 ) { 
		w.init ( 1 , 1 , n ) ;
		for ( i = 1 ; i <= n ; i ++ ) {
			aux1 += w.query ( 1 , 1 , n , a[ i ] , n ) ;
			w.update ( 1 , 1 , n , a[ i ] , 1 ) ;
		}
		w.init ( 1 , 1 , n ) ;
		for ( i = 1 ; i <= n ; i ++ ) {
			aux2 += w.query ( 1 , 1 , n , b[ i ] , n ) ;
			w.update ( 1 , 1 , n , b[ i ] , 1 ) ;
		}
		aux1 %= 2 ;
		aux2 %= 2 ;
		if ( aux1 != aux2 ) { printf ( "0\n" ) ; return ; }
	}
	long long hsum = 0 ;
	for ( i = 1 ; i <= n ; i ++ ) {
		if ( ( pos1[ i ] % k ) != ( pos2[ i ] % k ) ) { printf ( "0\n" ) ; return ; }
		hsum += ( pos1[ i ] - pos2[ i ] ) ;
	}
	if ( hsum != 0 ) { printf ( "0\n" ) ; return ; }
	if ( ( k % 2 ) == 0 ) { printf ( "1\n" ) ; return ; }
	printf ( "%d\n" , ( rand ( ) % 2 ) ) ; 
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
