#include "xbgame.h"
#include <vector>
#include <iostream>

#define random(x) (rand() % x)
#define rnd(lo,hi) ((lo) + (random(((hi)-(lo)+1))))

using namespace std;

int N,Row,Col;
bool Start=true;
bool T[102][102];
bool H=true;

void initT()
{for (int i=1;i<=N;i++)
  for (int j=1;j<=N;j++) T[i][j]=false;
 for (int i=0;i<=N+1;i++)
 {T[0][i]=true;
  T[N+1][i]=true;
  T[i][0]=true;
  T[i][N+1]=true;
 }
 T[Row][Col]=true;
}

void makeMove(int R,int C,bool H)
{T[Row][Col]=true;
 if (H)
 {int st=(Col<C?-1:1);
  for (int i=C;i!=Col;i+=st) T[Row][i]=true;
 }
 else
 {int st=(Row<R?-1:1);
  for (int i=R;i!=Row;i+=st) T[i][Col]=true;
 }
 Row=R;Col=C;
}

void getMove(int &R, int &C)
{vector<int> a;
 if (H)
 {for(int i=Col+1;!T[Row][i];i++) a.push_back(i);
  for(int i=Col-1;!T[Row][i];i--) a.push_back(i);
  R=Row;C=a[rnd(0,a.size()-1)];
 }
 else
 {for (int i=Row+1;!T[i][Col];i++) a.push_back(i);
  for (int i=Row-1;!T[i][Col];i--) a.push_back(i);
  R=a[rnd(0,a.size()-1)];C=Col;
 }
}

void play(int &R,int &C)
{
	srand(27071999);
	xbgame(N,R,C);
 if (Start)
 {Row=R;Col=C;
  initT();
  Start=false;
  if (false)
  {R=C=0;
   H=false;
   return;//skip first move
  }
  getMove(R,C);
  makeMove(R,C,H);
  return;
 }
 makeMove(R,C,!H);//executing opponent's move
 getMove(R,C);//get next move
 makeMove(R,C,H);//execute the move
}
