#include<iostream>
using namespace std;
const int MAX_N=100100;
long long n,k;
long long k2;
long long p[MAX_N];
long long posp[MAX_N];
long long posq[MAX_N];
long long p2[MAX_N];
long long q[MAX_N];
int ans=1;
void input()
{
    cin>>n>>k;
    for (int i=0; i<n; ++i)
    {
        cin>>p[i];
        --p[i];
    }
    for (int i=0; i<n; ++i)
    {
        cin>>q[i];
        --q[i];
    }
}
void output()
{
    cout<<ans<<endl;
}
long long it[MAX_N];
void update(int pos)
{
    ++pos;
    while (pos<=n)
    {
        ++it[pos];
        pos+=pos&(-pos);
    }
}
long long get(int pos)
{
    ++pos;
    long long sum=0;
    while (pos>0)
    {
        sum+=it[pos];
        pos-=pos&(-pos);
    }
    return sum;
}
void solve()
{
    long long diffs=0;
    long long diff=0;
    k2=2*k;
    ans=1;
    long long c2=0;
    for (int i=0; i<n; ++i)
    {
        p2[q[i]]=p[i];
        posp[p[i]]=i;
        posq[q[i]]=i;
    }
    for (int i=0; i<n; ++i)
    {
        if (posp[q[i]]==posq[p[i]] && p[i]!=q[i]) ++c2;
    }
    c2/=2;
    //cerr<<c2<<endl;
    /*for (int i=0;i<n;++i)
    {
        cerr<<p2[i]+1<<' ';
    }
    cerr<<endl;*/
    for (int i=0; i<n; ++i)
    {
        diff=posp[i]-posq[i];
        //cerr<<diff<<' ';
        if (diff<0) diff=-diff;
        if (diff%k!=0) //correct
        {
            ans=0;
            return;
        }
        diffs+=diff;
    }
    //cerr<<endl;
    if (diffs%k2!=0) //correct
    {
        ans=0;
        return;
    }
    long long inv=0;
    //cerr<<"diffs: "<<diffs<<endl;
    for (int i=n-1; i>=0; --i)
    {
        inv+=get(p2[i]);
        update(p2[i]);
    }
    //cerr<<"inv: "<<inv<<endl;
    if (inv%2!=0 && k%2==0) //number of inversions should be divisible by two //correct
    {
        ans=0;
        return;
    }
    /*cerr<<"here"<<endl;
    cerr<<c2%k<<endl;*/
    if (c2%k!=0)
    {
        ans=0;
    }
}
int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
