#include <iostream>
#include <cstdio>
#include <vector>
#include <set>

#define endl '\n'

using namespace std;

int n, k, x;

vector<int> v1, v2;
set<int> s[50002];

int main ()
{
    //freopen("i2.txt", "r", stdin);
    ios::sync_with_stdio(false);cin.tie(NULL);
    cin>>n>>k;
    for(int i=0; i<n; ++i)
    {
        cin>>x;
        v1.push_back(x);
    }
    for(int i=0; i<n; ++i)
    {
        cin>>x;
        v2.push_back(x);
    }
    if(k==1)
    {
        cout<<"1\n";
        return 0;
    }
    int diff, same, ans=1, prevdiff=-1, prevsame=-1;
    for(int i=0; i<k; ++i)
    {
        //cout<<"i="<<i<<endl;
        diff=same=0;
        for(int j=i; j<n && ans==1; j+=k)
        {
            if(v1[j]==v2[j])
            {
                same++;
            }
            else
            {
                diff++;
            }
        }
        if(prevdiff==-1)
        {
            prevdiff=diff;
            prevsame=same;
        }
        else
        if(prevdiff!=diff || prevsame!=same)
        {
            ans=0;
        }
    }
    if(ans==1)
    {
        for(int i=0; i<k; ++i)
        {
            for(int j=i; j<n; j+=k)
            {
                s[i].insert(v1[j]);
            }
        }
        for(int i=0; i<n; ++i)
        {
            x=i%k;
            if(s[x].find(v2[i])!=s[x].end())
            {
                s[x].erase(v2[i]);
            }
            else
            {
                cout<<"0\n";
                return 0;
            }
        }
        cout<<"1\n";
    }
    else cout<<"0\n";
    return 0;
}
