#include <bits/stdc++.h>
#include "xbgame.h"
using namespace std;
const int MAX_N=1024;
const int INF=MAX_N*MAX_N;
int lvl[MAX_N], n, m, source, target, head[MAX_N], ptr[MAX_N], path[MAX_N], path_len, tree[MAX_N];
bool Start=true;
bool toLeft=0;
bool First=true;
int N;
struct edge
{
    int to, next, rd;
    edge () {};
    edge (int to_, int next_, int rd_)
    {
        to=to_;
        next=next_;
        rd=rd_;
    }
};
edge e[2*MAX_N];
bool BFS(int u)
{
    memset(lvl, -1, sizeof(lvl));
    queue<int> q;
    q.push(u);
    lvl[u]=0;
    while(!q.empty())
    {
        u=q.front();
        q.pop();
        for(int i=head[u]; i!=-1; i=e[i].next)
            if(lvl[e[i].to]==-1&&e[i^1].rd>0)
            {
                lvl[e[i].to]=lvl[u]+1;
                q.push(e[i].to);
            }
    }
    return (lvl[source]!=-1);
}
long long int DFS(int u)
{
    if(u==target)
        return INF;
    for(int i=ptr[u]; i!=-1; i=ptr[i]=e[i].next)
        if(lvl[e[i].to]==lvl[u]-1&&e[i].rd>0)
        {
            path[path_len++]=e[i].to;
            int tek_flow=DFS(e[i].to);
            if(tek_flow)
                return min(tek_flow, e[i].rd);
            path_len--;
        }
    return 0;
}
void update_graph(int tek_flow)
{
    for(int i=0; i<path_len; i++)
    {
        e[path[i]].rd-=tek_flow;
        e[path[i]^1].rd+=tek_flow;
    }
}
long long int Dinitz()
{
    long long int max_flow=0, tek_flow;
    while(BFS(target))
    {
        copy(head, head+n+3, ptr);
        while(path_len=0, tek_flow=DFS(source))
        {
            max_flow+=tek_flow;
            update_graph(tek_flow);
        }
    }
    printf("%lld\n", max_flow);
    return max_flow;
}

void updateFenwick(int index, int value)
{
    for(; index<=n; index+=index&(-index))
        tree[index]+=value;
}
int getSumFenwick(int index)
{
    int ans=0;
    for(; index; index-=index&(-index))
        ans+=tree[index];
    return ans;
}
int queryFenwick(int left, int right)
{
    return getSumFenwick(right)-getSumFenwick(left-1);
}
void play(int &R, int &C)
{
    xbgame(N, R, C);
    if(Firt)
    {
        First=0;
        if(C==N)
            toLeft=1;
    }
    if(toLeft)
        C=1;
    else
        C=N;
}
