#include <iostream>
#include <utility>
#define fi first
#define se second
using namespace std;

void xbgame (int &N, int &R, int &C);

const int MAXN = 128;

int n, r, c;
bool start = true, s2 = false;

bool mat[MAXN][MAXN];
pair<int, int> pm;

pair<int, int> makeMove(pair<int, int> p)
{
    int dir;
    if (p.se - 1 >= 1 and mat[p.fi][p.se - 1] == 0) dir = -1;
    if (p.se + 1 <= n and mat[p.fi][p.se + 1] == 0) dir = +1;

    while (p.se + dir >= 1 and p.se + dir <= n)
    {
        p.se += dir;
        mat[p.fi][p.se] = 1;
    }
    return p;
}

void play(int &R, int &C)
{
    if (start)
    {
        xbgame(n, r, c);
        start = false;
        mat[r][c] = 1;

        if ((r == 1 or r == n) and (c == 1 and c == n))
        {
            s2 = true;
            pm = makeMove(make_pair(r, c));
            R = pm.fi; C = pm.se;
            return;
        }
        else while(true);
    }
    else
    {
        int dir;
        if (pm.fi < R) dir = +1;
        if (pm.fi > R) dir = -1;

        while (pm.fi + dir >= 1 and pm.fi + dir <= n)
        {
            pm.fi += dir;
            mat[pm.fi][pm.se] = 1;
        }

        pm = makeMove(pm);
        R = pm.fi; C = pm.se;
        return;
    }
}


