#include <iostream>
#include <utility>
#define fi first
#define se second
using namespace std;

void xbgame (int &N, int &R, int &C);
/*{
    cout << "next move" << endl;
    cin >> N >> R >> C;
    if (N == -1)
    {
        cout << "win" << endl;
    }
}*/

const int MAXN = 128;

int n, r, c;
bool start = true, s2 = false;

bool matr[MAXN][MAXN];
pair<int, int> pm;

pair<int, int> makeMove(pair<int, int> p)
{
    int dir;
    if (p.se - 1 >= 1 and matr[p.fi][p.se - 1] == 0) dir = -1;
    if (p.se + 1 <= n and matr[p.fi][p.se + 1] == 0) dir = +1;
   // cout << "dir: " << dir << endl;

    while (p.se + dir >= 1 and p.se + dir <= n)
    {
        p.se += dir;
        matr[p.fi][p.se] = 1;
    }
   // cout << "fin y: " << p.se << endl;
    return p;
}

void play(int &R, int &C)
{
    xbgame(n, r, c);
    if (start)
    {
        start = false;
        matr[r][c] = 1;

        if ((r == 1 or r == n) and (c == 1 or c == n))
        {
            s2 = true;
            pm = makeMove(make_pair(r, c));
            R = pm.fi; C = pm.se;
            return;
        }
        else while(true);
    }
    else
    {
        int dir;
        if (pm.fi < r) dir = +1;
        if (pm.fi > r) dir = -1;

        while (pm.fi + dir >= 1 and pm.fi + dir <= r)
        {
            pm.fi += dir;
            matr[pm.fi][pm.se] = 1;
        }

        // cout << pm.fi << ' ' << pm.se << endl;

        pm = makeMove(pm);
        R = pm.fi; C = pm.se;
        return;
    }
}

/*
int main()
{
    while (true)
    {
        int rr, cc;
        play(rr, cc);
        cout << "my move: " << rr << ' ' <<cc << endl;
    }
}

*/
