#include <cstdio>
using namespace std;

#define MaxPermLen 100000

int permLen, groupLen;

bool Belongs(int perm1[], int perm2[])
{
    for (int i = 0; i < permLen; i++)
    {
        for (int j = 0; j < permLen; j++)
        {
            if (perm1[i] == perm2[j] && (i - j) % groupLen != 0)
            {
                return false;
            }
        }
    }

    return true;
}

int main()
{
    scanf("%d%d", &permLen, &groupLen);

    int perm1[MaxPermLen], perm2[MaxPermLen];
    for (int i = 0; i < permLen; i++)
    {
        scanf("%d", &perm1[i]);
    }
    for (int i = 0; i < permLen; i++)
    {
        scanf("%d", &perm2[i]);
    }

    if (Belongs(perm1, perm2))
    {
        printf("1\n");
    }
    else
    {
        printf("0\n");
    }

    return 0;
}
