#include "xbgame.h"
#include <vector>
#include <iostream>
using namespace std;

bool m[128][128];
int myN, sx, sy;

void play(int &R,int &C);
int lastX, lastY;

int hor( int x, int y );

int ver ( int x, int y ) {

    int cntD = 0;
    if ( y > 0 && m[y-1][x] == 0 ) { cntD ++; }
    if ( y+1 < myN && m[y+1][x] == 0 ) { cntD ++; }

    if ( cntD == 0 ) { return 0; }
    if ( cntD == 1 ) {
        if ( y > 0 && m[y-1][x] == 0 ) {
            int ny = y-1;
            for ( ; ny >= 0 && m[ny][x] == 0 ; ny -- ) { m[ny][x] = 1; }
            ny ++;

            bool b = hor(x, ny );
            for ( int cy = ny ; cy < y ; cy ++ ) { m[cy][x] = 0; }
            if ( b == 0 ) { return -1; }
        }
        else {
            int ny = y+1;
            for ( ; ny < myN && m[ny][x] == 0 ; ny ++ ) { m[ny][x] = 1; }
            ny --;

            bool b = hor(x, ny );
            for ( int cy = y ; cy <= ny ; cy ++ ) { m[cy][x] = 0; }
            if ( b == 0 ) { return 1; }
        }
    }else {
        int ny = y-1;
        for ( ; ny >= 0 && m[ny][x] == 0 ; ny -- ) { m[ny][x] = 1; }
        ny ++;

        bool b1 = hor( x, ny );
        for ( int cy = ny ; cy < y ; cy ++ ) { m[cy][x] = 0; }
        if ( b1 == 0 ) { return 1; }

        ny = y+1;
        for ( ; ny < myN && m[ny][x] == 0 ; ny ++ ) { m[ny][x] = 1; }
        ny --;

        bool b = hor(x, ny );
        for ( int cy = y ; cy <= ny ; cy ++ ) { m[cy][x] = 0; }
        if ( b == 0 ) { return -1; }
    }
}

int hor ( int x, int y ) {
    int cntD = 0;
    if ( x > 0 && m[y][x-1] == 0 ) { cntD ++; }
    if ( x+1 < myN && m[y][x+1] == 0 ) { cntD ++; }

    if ( cntD == 0 ) { return 0; }
    if ( cntD == 1 ) {
        if ( x > 0 && m[y][x-1] == 0 ) {
            int nx = x-1;
            for ( ; nx >= 0 && m[y][nx] == 0 ; nx -- ) { m[y][nx] = 1; }
            nx ++;

            bool b = ver(nx, y );
            for ( int cx = nx ; cx < x ; cx ++ ) { m[y][cx] = 0; }
            if ( b == 0 ) { return -1; }
        }
        else {
            int nx = x+1;
            for ( ; nx < myN && m[y][nx] == 0 ; nx ++ ) { m[y][nx] = 1; }
            nx --;

            bool b = ver(nx, y );
            for ( int cx = x ; cx <= nx ; cx ++ ) { m[y][cx] = 0; }
            if ( b == 0 ) { return 1; }
        }
    }else {

        int nx = x-1;
        for ( ; nx >= 0 && m[y][nx] == 0 ; nx -- ) { m[y][nx] = 1; }
        nx ++;

        bool b1 = ver(nx, y );
        for ( int cx = nx ; cx < x ; cx ++ ) { m[y][cx] = 0; }
        if ( b1 == 0 ) { return -1; }

        nx = x+1;
        for ( ; nx < myN && m[y][nx] == 0 ; nx ++ ) { m[y][nx] = 1; }
        nx --;

        bool b = ver(nx, y );
        for ( int cx = x ; cx <= nx ; cx ++ ) { m[y][cx] = 0; }
        if ( b == 0 ) { return 1; }

    }
}
bool ish;
bool madeMove = 0;
void play ( int &R, int &C ) {

    xbgame ( myN, sy, sx );
    sx --;
    sy --;


   // cout << "started : "<< myN << " "<< sy << " "<< sx << "\n";

    m[sy][sx] = 1;
    int cx = C-1, cy = R-1;
    if ( madeMove == 0 ) {
        cx = sx;
        cy = sy;
    }

    if ( !madeMove ) {
     //   cout << "first move\n";

        int crr = hor(sx, sy );
        if ( crr == 0 ) {
            R = 0; C = 0;
            ish = 0;
            lastY = cy;
            lastX = cx;
            madeMove = 1;
            return ;
        }else {
            ish = 1;
            if ( crr  == 1 ) {
                int nx = cx +1;
                for ( ; nx < myN && m[cy][nx] == 0 ; nx ++ ) { m[cy][nx] = 1; }
                nx --;

                cx = nx;
                R = cy +1;
                C = cx +1;

            }else if ( crr == -1 ) {

                int nx = cx -1;
                for ( ; nx >= 0 && m[cy][nx] == 0 ; nx -- ) { m[cy][nx] = 1; }
                nx ++;

                cx = nx;

                R = cy +1;
                C = cx +1;
            }else {
          //      cout << "bla <-------------------- \n";
            }
            madeMove = 1;

        }
    }else {
        madeMove = 1;
        if ( ish ) {
            int y = min( lastY, cy );
            for ( ; y <= max( lastY, cy ); y ++ ) { m[y][cx] = 1; }

            int crr = hor( cx, cy );
            if ( crr  == 1 ) {
                int nx = cx +1;
                for ( ; nx < myN && m[cy][nx] == 0 ; nx ++ ) { m[cy][nx] = 1; }
                nx --;

                cx = nx;
                R = cy +1;
                C = cx +1;

            }else if ( crr == -1 ) {

                int nx = cx -1;
                for ( ; nx >= 0 && m[cy][nx] == 0 ; nx -- ) { m[cy][nx] = 1; }
                nx ++;

                cx = nx;

                R = cy +1;
                C = cx +1;
            }else {
          //      cout << "bla <-------------------- \n";
            }
        }else {
            int x = min( lastX, cx );
            for ( ; x <= max( lastX, cx ); x ++ ) { m[cy][x] = 1; }

            int crr = ver( cx, cy );
            if ( crr  == 1 ) {
                int ny = cy +1;
                for ( ; ny < myN && m[ny][cx] == 0 ; ny ++ ) { m[ny][cx] = 1; }
                ny --;

                cy = ny;
                R = cy +1;
                C = cx +1;

            }else if ( crr == -1 ) {

                int ny = cy -1;
                for ( ; ny >= 0 && m[ny][cx] == 0 ; ny -- ) { m[ny][cx] = 1; }
                ny ++;

                cy = ny;

                R = cy +1;
                C = cx +1;
            }else {
           //     cout << "bla <-------------------- \n";
            }

        }

    }




    lastY = cy;
    lastX = cx;
}
