#include <iostream>
#include <vector>
#include <cstdlib>
using namespace std;
int n, m, q;
int cap[128][128];
int cf[128][128];

int capcop[128][128];
int cfcop[128][128], ansFCop;

int aq[128], bq[128];

void addEdge ( int x, int y ) {

    cap[x][y] ++;
    cap[y][x] ++;
}

int ansF = 0;
int used[128], usedTst;
int bSz = 1;

bool getF ( int x ) {
    if ( x == n ) { return 1; }
    if ( used[x] == usedTst ) { return 0; }
    used[x] = usedTst;
//    cout << "reached "<< x << "  "<< cf << "\n";

    for ( int i = n ; i >= 1 ; i -- ) {
        if ( cap[x][i] > cf[x][i] ) {

            int nf = getF ( i );
            if ( nf ) {

                cf[x][i] ++;
                cf[i][x] --;
                return 1;
            }
        }
    }
    return 0;
}
bool tryBsz ( int s) {

    for ( int j = s ; j < q && j < s +bSz ; j ++ ) {
        addEdge ( aq[j], bq[j] );
    }

    while ( 1 ) {
        usedTst ++;
        int cff = getF( 1 ) ;
        ansF += cff;
//        cout << "+cf\n";
        if ( cff == 0 ) { break; }
    }
    return ansF == ansFCop;
}

void cop ( ){
    ansFCop = ansF;
    for ( int i = 0 ; i <= n ; i ++ ) {
        for ( int j = 0 ; j <= n ; j ++ ) {
            cfcop[i][j] = cf[i][j];
            capcop[i][j] = cap[i][j];
        }
    }
}
void restore () {
    ansF = ansFCop;
    for ( int i = 0 ; i <= n ; i ++ ) {
        for ( int j = 0 ; j <= n ; j ++ ) {
            cf[i][j] = cfcop[i][j];
            cap[i][j] = capcop[i][j];
        }
    }

}


int main () {

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;

    for ( int i = 0 ; i < m ; i ++ ) {
        int a, b;
        cin >> a >> b;
        addEdge ( a, b );
    }
    while ( 1 ) {
        usedTst ++;
        int cf = getF( 1 ) ;
        ansF += cf;
//        cout << "+cf\n";
        if ( cf == 0 ) { break; }
    }
    cout << ansF << "\n";
    cin >> q;

    for ( int i = 0 ; i < q ; i ++ ) {
        cin >> aq[i] >> bq[i];
    }
    for ( int i = 0 ; i < q ; ) {

        cop();
        if ( 0 && tryBsz ( i ) ) {
           // cout << "ok "<< i << ": "<< i+bSz << "\n";
            for ( int j = 0 ; i+j < q && j < bSz ; j ++ ) {
                cout << ansF << "\n";
            }
            i += bSz;
        }else {

            restore();
            for ( int j = i ; j < q && j < i +bSz ; j ++ ) {
                addEdge ( aq[j], bq[j] );

                while ( 1 ) {
                    usedTst ++;
                    int cff = getF( 1 ) ;
                    ansF += cff;
            //        cout << "+cf\n";
                    if ( cff == 0 ) { break; }
                }

                cout << ansF << "\n";
            }
            i += bSz;

        }


    }
    return 0;
}
/*5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5


5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5


5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5

*/
