#include<iostream>
#include<queue>
using namespace std;
struct road
{
    int cap, used;
} e[100][100];
int n, m, q;
int ans = 0;

bool max_flow()
{
    queue<pair<int,int> > d;
    d.push({100000, 0});
    int from[100];
    for(int i = 0; i < n; i ++) from[i] = -1;
    from[0] = -2;
    while(!d.empty())
    {
        pair<int,int> p = d.front();
        d.pop();
        if(p.second == n - 1)
        {
            ans ++;
            int c = n - 1;
            while(c != 0)
            {
                if(from[c] < c)
                {
                    e[from[c]][c].used ++;
                } else {
                    e[c][from[c]].used --;
                }
                c = from[c];
            }
            return true;
        }
        for(int i = p.second + 1; i < n; i ++) // up to cap
        {
            if(from[i] == -1 && e[p.second][i].used < e[p.second][i].cap)
            {
                from[i] = p.second;
                d.push({min(p.first, e[p.second][i].cap - e[p.second][i].used), i});
            }
        }
        for(int i = 0; i < p.second; i ++) // up to -cap
        {
            if(from[i] == -1 && e[i][p.second].used > -e[i][p.second].cap)
            {
                from[i] = p.second;
                d.push({min(p.first, e[i][p.second].used + e[i][p.second].cap), i});
            }
        }
    }
    return false;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 0; i < m; i ++)
    {
        int a, b;
        cin >> a >> b;
        if(a > b)   swap(a, b);
        a--, b--;
        e[a][b].cap = 1;
        e[a][b].used = 0;
    }
    while(max_flow()){}
    cout << ans << "\n";
    cin >> q;
    for(int i = 0; i < q; i ++)
    {
        int a, b;
        cin >> a >> b;
        if(a > b)   swap(a, b);
        a--, b--;
        e[a][b].cap ++;
        max_flow();
        cout << ans << "\n";
    }
}
/*
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
0
*/
/*
5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5
*/
