#include "xbgame.h"
#include <iostream>

int posx, posy, _n;
bool _first;
int prevpx, prevpy;

bool field[100][100];

void play(int &R, int &C) {
	xbgame(_n, posy, posx);
	posx --;
	posy --;

	if(_first) {
		_first = false;
	} else {
		int mx = std::min(prevpx, posx);
		int bx = std::max(prevpx, posx);
		for(int x = mx;x < bx;x ++) field[x][posy] = true;

		int my = std::min(prevpy, posy);
		int by = std::max(prevpy, posy);
		for(int y = my;y < by;y ++) field[posx][y] = true;
	}

	int npx = 0, npy = posy;

	int bestd = 1 << 30;
	for(int i = posx + 1;i < _n;i ++) {
		if(field[i][posy]) break;
		int d = 0;
		for(int j = posy;j < _n;j ++) {
			if(field[i][j]) break;
			d ++;
		}
		for(int j = posy-1;j >= 0;j --) {
			if(field[i][j]) break;
			d ++;
		}
		if(d < bestd) { // TODO other way around?
			bestd = d;
			npx = i;
		}
	}

	for(int i = posx - 1;i >= 0;i --) {
		if(field[i][posy]) break;
		int d = 0;
		for(int j = posy;j < _n;j ++) {
			if(field[i][j]) break;
			d ++;
		}
		for(int j = posy-1;j >= 0;j --) {
			if(field[i][j]) break;
			d ++;
		}
		if(d < bestd) { // TODO other way around?
			bestd = d;
			npx = i;
		}
	}

	prevpx = posx;
	prevpy = posy;

	std::cout << "WTF pl " << R << ' ' << C << std::endl;
	R = npy + 1;
	C = npx + 1;
}
