#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 + 5;
int INF;

int n, k;
int p[N], q[N];

int inv_p[N], inv_q[N];


int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr); cout.tie(nullptr);

   int i;

   cin >> n >> k;
   for(i = 1; i <= n; i++)
   {
       cin >> p[i];
       inv_p[p[i]] = i;
   }
   for(i = 1; i <= n; i++)
   {
       cin >> q[i];
       inv_q[q[i]] = i;
   }

   INF = k;
   while(INF <= n)
     INF += k;

   for(i = 1; i <= n; i++)
   {
        int delta = (inv_q[i] - inv_p[i]) + INF;

        if(delta % k != 0)
        {
            cout << 0 << endl;
            return 0;
        }
   }

   cout << 1 << endl;

   return 0;
}
