#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 + 5;
const double TL = 0.17;
int INF;

int n, k;
int p[N], q[N];

int inv_p[N], inv_q[N];

int moves;

int abs(int x)
{
    if(x < 0)
        return -x;
    return x;
}

int count_inv(int arr[])
{
    int i, j;
    int res = 0;
    for(i = 1; i <= n; i++)
    {
        for(j = i + 1; j <= n; j++)
        {
            if(arr[i] > arr[j])
                res++;
        }
    }

    return res;
}

int main()
{
   srand(time(NULL));
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr); cout.tie(nullptr);

   int i;

   cin >> n >> k;
   for(i = 1; i <= n; i++)
   {
       cin >> p[i];
       inv_p[p[i]] = i;
   }
   for(i = 1; i <= n; i++)
   {
       cin >> q[i];
       inv_q[q[i]] = i;
   }

   INF = k;
   while(INF <= n)
     INF += k;

   for(i = 1; i <= n; i++)
   {
        int delta = (inv_q[i] - inv_p[i]) + INF;

        if(delta % k != 0)  /// neobhodimo, no ne dostatuchno uslovie
        {
            moves += inv_q[i] - inv_p[i];

            cout << 0 << endl;
            return 0;
        }
   }

   if(moves != 0)
   {
       cout << 0 << endl;
       return 0;
   }

   int diff = count_inv(p) - count_inv(q) + INF;
   if(diff % k != 0)
   {
       cout << 0 << endl;
       return 0;
   }


   cout << 1 << endl;

   return 0;
}


/*

5 2
5 3 2 1 4
2 1 4 3 5

*/
