#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <cstdlib>
#include <random>
#include <ctime>
using namespace std;

int n, k;
vector<int> p, q;
void read()
{
    cin>>n>>k;
    p.resize(n);
    for(int &x : p)cin>>x;
    q.resize(n);
    for(int &x : q)cin>>x;
}

void solve()
{
    if(p==q)
    {
        puts("1");
        return;
    }

    if(k*2==n)
    {
        bool impossible = false;
        for(int i=0;i<k;i++)
        {
            if(p[i]!=q[i+k])impossible = true;
            if(p[k+i]!=q[i])impossible = true;
            if(impossible)break;
        }

        if(impossible)
        {
            puts("0");
            return;
        }
    }



    puts("1");
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return EXIT_SUCCESS;
}
/**
6 2
5 6 1 2 3 4
3 6 5 2 1 4


4 2
3 4 2 1
4 3 2 1

4 2
1 2 3 4
3 4 1 2
**/
