#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <cstdlib>
#include <random>
#include <ctime>
using namespace std;

int n, k;
vector<int> p, q;
void read()
{
    cin>>n>>k;
    p.resize(n);
    for(int &x : p)cin>>x;
    q.resize(n);
    for(int &x : q)cin>>x;
}

void perform(int from)
{
    for(int i=0;i<k;i++)
    {
        swap(p[from+i], p[from+k+i]);
    }
}

void go(int last = -1)
{
    /*printf("going with: ");
    for(int x : p)printf("%d ", x);
    putchar('\n');*/
    if(p==q)
    {
        puts("1");
        exit(0);
    }
    for(int i=0;i<=n-2*k;i++)
    {
        if(i==last)continue;
        perform(i);
        go(i);
        perform(i);
    }
}

void solve()
{
    if(p==q)
    {
        puts("1");
        return;
    }

    if(k*2==n)
    {
        bool impossible = false;
        for(int i=0;i<k;i++)
        {
            if(p[i]!=q[i+k])impossible = true;
            if(p[k+i]!=q[i])impossible = true;
            if(impossible)break;
        }

        if(impossible)puts("0");
        else puts("1");
        return;
    }

    go();
    puts("0");
    return;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return EXIT_SUCCESS;
}
/**
6 3
5 6 1 2 3 4
3 6 5 2 1 4

6 2
5 6 1 2 3 4
3 6 5 2 1 4

20 2
5 6 1 2 3 4 7 8 9 10 11 12 13 14 15 16 17 18 19 20
3 6 5 2 1 4 7 8 9 10 11 12 13 14 15 16 17 18 19 20


4 2
3 4 2 1
4 3 2 1

4 2
1 2 3 4
3 4 1 2
**/
