#include<iostream>
#include<vector>
#include<queue>
using namespace std;
void bfs(int start, vector<vector<int>> b, int n)
{
    queue<int> cur;
    cur.push(start);
    int ans=0;
    for(vector<int> i : b)
    {
        for(int j : i)
        {
            cout<<j<<" ";
        }
        cout<<endl;
    }
    while(!cur.empty())
    {
        int x=cur.front();
        cur.pop();
        for(int i=1; i<=n; i++)
        {
            if(b[x][i]!=0)
            {
                if(i==n)ans++;
                else cur.push(i);
                b[x][i]--;
                b[i][x]--;
            }
        }
    }
    cout<<ans<<endl;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m,q;
    vector<vector<int>> a;
    cin>>n>>m;
    a.resize(n+1, vector<int>(n+1));
    for(int i=1;i<=m;i++)
    {
        int x,y;
        cin>>x>>y;
        a[x][y]++;
        a[y][x]++;
    }
    bfs(1, a, n);
    cin>>q;
    for(int i=1;i<=q;i++)
    {
        int x,y;
        cin>>x>>y;
        a[x][y]++;
        a[y][x]++;
        bfs(1,a,n);
    }
    return 0;
}
/*
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
*/
