#include "xbgame.h"
#include <vector>
#include <iostream>

#define random(x) (rand() % x)
#define rnd(lo,hi) ((lo) + (random(((hi)-(lo)+1))))

using namespace std;

int N,Row,Col;
bool Start=true;
bool T[102][102];
bool H=true;
bool P=true;

void initT()
{for (int i=1;i<=N;i++)
  for (int j=1;j<=N;j++) T[i][j]=false;
 for (int i=0;i<=N+1;i++)
 {T[0][i]=true;
  T[N+1][i]=true;
  T[i][0]=true;
  T[i][N+1]=true;
 }
 T[Row][Col]=true;
}

void makeMove(int R,int C,bool H)
{T[Row][Col]=true;
 if (H)
 {int st=(Col<C?-1:1);
  for (int i=C;i!=Col;i+=st) T[Row][i]=true;
 }
 else
 {int st=(Row<R?-1:1);
  for (int i=R;i!=Row;i+=st) T[i][Col]=true;
 }
 Row=R;Col=C;
}

void getMove(int &R, int &C, bool &P)
{vector<int> a;
int maxa=0;
int maxb=0;
 if (H)
 {for(int i=Col+1;!T[Row][i];i++)maxa=i;
  for(int i=Col-1;!T[Row][i];i--)maxb=i;
  R=Row;
  if(P==true)C=maxa;
  if(P==false)C=maxb;
 }
}

void play(int &R,int &C)
{xbgame(N,R,C);
 if (Start)
 {Row=R;Col=C;

  initT();
  Start=false;

  getMove(R,C,P);
  if(P==true)P=false;
  else P=true;
  makeMove(R,C,H);
  return;
 }
 makeMove(R,C,!H);//executing opponent's move
 getMove(R,C,P);//get next move
 if(P==true)P=false;
  else P=true;
 makeMove(R,C,H);//execute the move
}
