#include <bits/stdc++.h>
#include "xbgame.h"
using namespace std;

const int32_t MAX_N = 100;

bool isVisited[MAX_N + 5][MAX_N + 5];
int lastR, lastC;

void play(int &R, int &C) {
	int n, r, c;
	xbgame(n, r, c);
	
	if(lastR != 0) {
		for(int32_t i = min(lastR, r); i <= max(lastR, r); i++) {
			isVisited[i][lastC] = true;
		}
	}

	if(c == 1 || isVisited[r][c - 1]) {
		R = r;
		
		c++;
		while(c <= n && !isVisited[r][c]) {
			isVisited[r][c] = true;
			c++;
		}	
		c--;

		C = c;

		lastR = R;
		lastC = C;

		return;
	}
	else {
		R = r;
		
		c--;
		while(c >= 1 && !isVisited[r][c]) {
			isVisited[r][c] = true;	
			c--;
		}
		c++;

		C = c;

		lastR = R;
		lastC = C;
		
		return;
	}
}
