#include<bits/stdc++.h>
using namespace std;
int n,k;
int p[100005];
int q[100005];
vector<int> v[100005];
vector<int> f[100005];
int place[100005];
int pos[100005];
void read()
{
    int i,j;
    cin>>n>>k;
    for(i=1;i<=n;i++)
        cin>>p[i];
    for(i=1;i<=n;i++)
        cin>>q[i];
    for(i=1;i<=k;i++)
    {
        v[i].push_back(0);
        f[i].push_back(0);
        for(j=i;j<=n;j+=k)
        {
            pos[q[j]]=f[i].size();
            v[i].push_back(p[j]);
            place[p[j]]=i;
            f[i].push_back(q[j]);
        }
        for(j=i;j<=n;j+=k)
        {
            if(place[q[j]]!=i)
            {
                cout<<0<<endl;
                exit(0);
            }
        }
    }
}
int tree[500005];
void init(int idx, int l, int r)
{
    if(l==r)
    {
        tree[idx]=1;
        return;
    }
    int mid=(l+r)/2;
    init(idx*2,l,mid);
    init(idx*2+1,mid+1,r);
    tree[idx]=tree[idx*2]+tree[idx*2+1];
    return;
}
void update(int idx, int l, int r, int x)
{
    if(l>x||r<x||l>r)
        return;
    if(l==r)
    {
        tree[idx]=0;
        return;
    }
    int mid=(l+r)/2;
    update(idx*2,l,mid,x);
    update(idx*2+1,mid+1,r,x);
    tree[idx]=tree[idx*2]+tree[idx*2+1];
    return;
}
int sum(int idx, int l, int r, int u, int v)
{
    if(l>v||r<u||l>r)
        return 0;
    if(l>=u&&r<=v)
        return tree[idx];
    int mid=(l+r)/2;
    return sum(idx*2,l,mid,u,v)+sum(idx*2+1,mid+1,r,u,v);
}
int solve(int id)
{
    int i,j;
    int sz=v[id].size()-1;
    for(i=1;i<=sz;i++)
    {
        v[id][i]=pos[v[id][i]];
        //cout<<v[id][i]<<" ";
    }
    //cout<<endl;
    long long ans=0LL;
    init(1,1,sz);
    for(i=1;i<=sz;i++)
    {
        ans=ans+1LL*sum(1,1,sz,1,v[id][i]-1);
        update(1,1,sz,v[id][i]);
    }
    ans%=2LL;
    return ans;
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	read();
	int i;
	int br=0;
	for(i=1;i<=k;i++)
    {
        br+=solve(i);
    }
    if(br%k==0)
    {
        cout<<1<<endl;
    }
    else
    {
        cout<<0<<endl;
    }
	return 0;
}
