#include<iostream>
#include<vector>
#include<queue>
using namespace std;
const int MAX_N=128;
long long n,m;
long long k;
long long c[MAX_N][MAX_N];
long long ans=0;
long long INF=1<<9;
void input()
{
    cin>>n>>m;
    int a,b;
    for (int i=0; i<m; ++i)
    {
        cin>>a>>b;
        --a;
        --b;
        ++c[a][b];
        ++c[b][a];
    }
    cin>>k;
}
void output()
{
    cout<<ans<<'\n';
}
int level[MAX_N];
bool BFS()
{
    for (int i=0; i<n; ++i)
    {
        level[i]=-1;
    }
    level[0]=0;
    queue<int> q;
    q.push(0);
    int p;
    while (!q.empty())
    {
        p=q.front();
        q.pop();
        for (int i=0;i<n;++i)
        {
            if (i!=p && c[p][i]>0 && level[i]==-1)
            {
                level[i]=level[p]+1;
                q.push(i);
            }
        }
    }
    if (level[n-1]!=-1) return 1;
    else return 0;
}
long long DFS(int a, int cf)
{
    int nf;
    if (a==n-1) return cf;
    for (int i=0;i<n;++i)
    {
        if (i!=a && level[i]>level[a] && c[a][i]>0)
        {
            if (cf<c[a][i]) nf=DFS(i,cf);
            else nf=DFS(i,c[a][i]);
            if (nf>0)
            {
                c[a][i]-=nf;
                c[i][a]+=nf;
                return nf;
            }
        }
    }
    return 0;
}
void solve()
{
    int nc;
    while (BFS())
    {
        while (nc=DFS(0,INF))
        {
            ans+=nc;
        }
    }
}
int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();
    int a,b;
    for (int i=0;i<k;++i)
    {
        cin>>a>>b;
        --a;
        --b;
        ++c[a][b];
        ++c[b][a];
        solve();
        output();
    }

    return 0;
}
