#include "xbgame.h"
//#include "Lgrader.cpp"
#include <bits/stdc++.h>

#define random(x) (rand() % x)
#define rnd(lo,hi) ((lo) + (random(((hi)-(lo)+1))))

using namespace std;

int n,N,Row,Col;
bool Start=true;
bool T[102][102];
bool H=true;
bool used[107][107];
bool move_made;
int who;
int ansr,ansc;

void initT()
{for (int i=1;i<=N;i++)
  for (int j=1;j<=N;j++) T[i][j]=false;
 for (int i=0;i<=N+1;i++)
 {T[0][i]=true;
  T[N+1][i]=true;
  T[i][0]=true;
  T[i][N+1]=true;
 }
 T[Row][Col]=true;
}

void makeMove(int R,int C,bool H)
{T[Row][Col]=true;
 if (H)
 {int st=(Col<C?-1:1);
  for (int i=C;i!=Col;i+=st) T[Row][i]=true;
 }
 else
 {int st=(Row<R?-1:1);
  for (int i=R;i!=Row;i+=st) T[i][Col]=true;
 }
 Row=R;Col=C;
}

void getMove(int &R, int &C)
{vector<int> a;
 if (H)
 {for(int i=Col+1;!T[Row][i];i++) a.push_back(i);
  for(int i=Col-1;!T[Row][i];i--) a.push_back(i);
  R=Row;C=a[rnd(0,a.size()-1)];
 }
 else
 {for (int i=Row+1;!T[i][Col];i++) a.push_back(i);
  for (int i=Row-1;!T[i][Col];i--) a.push_back(i);
  R=a[rnd(0,a.size()-1)];C=Col;
 }
}

void set_row(int r, int l, int rr) {
  for(int i=l;i<=rr;i++) {
    used[r][i]=true;
  }
}

void set_col(int c, int u, int d) {
  for(int i=u;i<=d;i++) {
    used[i][c]=true;
  }
}

void unset_row(int r, int l, int rr) {
  for(int i=l;i<=rr;i++) {
    used[r][i]=false;
  }
}

void unset_col(int c, int u, int d) {
  for(int i=u;i<=d;i++) {
    used[i][c]=false;
  }
}

bool is_winning(int r, int c, int who) {
  int i;

  if(who==0) {
    for(i=c+1;i<=n;i++) {
      if(used[r][i]) break;
      
      set_row(r,c,i);
      if(!is_winning(r,i,1)) {
        unset_row(r,c,i);
        return true;
      }
      unset_row(r,c,i);
    }

    for(i=c-1;i>=1;i--) {
      if(used[r][i]) break;

      set_row(r,i,c);
      if(!is_winning(r,i,1)) {
        unset_row(r,i,c);
        return true;
      }      
      unset_row(r,i,c);
    }

    return false;
  }

  else {
    for(i=r+1;i<=n;i++) {
      if(used[i][c]) break;

      set_col(c,r,i);
      if(!is_winning(i,c,0)) {
        unset_col(c,r,i);
        return true;
      }
      unset_col(c,r,i);
    }

    for(i=r-1;i>=1;i--) {
      if(used[i][c]) break;

      set_col(c,i,r);
      if(!is_winning(i,c,0)) {
        unset_col(c,i,r);
        return true;
      }
      unset_col(c,i,r);
    }

    return false;
  }
}

void get_winning_move(int &r, int &c, int who) {
  int i;

  if(who==0) {
    for(i=c+1;i<=n;i++) {
      if(used[r][i]) break;
      
      set_row(r,c,i);
      if(!is_winning(r,i,1)) {
        ansr=r;
        ansc=i;
        return;
      }
      unset_row(r,c,i);
    }

    for(i=c-1;i>=1;i--) {
      if(used[r][i]) break;

      set_row(r,i,c);
      if(!is_winning(r,i,1)) {
        ansr=r;
        ansc=i;
        return;
      }      
      unset_row(r,i,c);
    }

    return;
  }

  else {
    for(i=r+1;i<=n;i++) {
      if(used[i][c]) break;

      set_col(c,r,i);
      if(!is_winning(i,c,0)) {
        ansr=i;
        ansc=c;
        return;
      }
      unset_col(c,r,i);
    }

    for(i=r-1;i>=1;i--) {
      if(used[i][c]) break;

      set_col(c,i,r);
      if(!is_winning(i,c,0)) {
        ansr=i;
        ansc=c;
        return;
      }
      unset_col(c,i,r);
    }

    return;
  }
}



void play(int &R,int &C)
{xbgame(N,R,C);
 if(N>10) {
 if (Start)
 {
  Row=R;Col=C;
  initT();
  Start=false;
  if (rnd(0,1))
  {R=C=0;
   H=false;
   return;//skip first move
  }
  getMove(R,C);
  makeMove(R,C,H);
  return;
 }
 makeMove(R,C,!H);//executing opponent's move
 getMove(R,C);//get next move
 makeMove(R,C,H);//execute the move
 return;
 }

  if(ansr==R) set_row(ansr,min(C,ansc),max(C,ansc));
  else set_col(ansc,min(ansr,R),max(ansr,R));

  used[R][C]=true;
  n=N;

  if(move_made==false) {
    move_made=true;
    if(is_winning(R,C,0)) {
      get_winning_move(R,C,0);
      ansr=R;
      ansc=C;
      who=0;
    }
    else {
      R=0;
      C=0;
      who=1;
    }
    return;
  }
  
  get_winning_move(R,C,who);
  R=ansr;
  C=ansc;
}
