#include <iostream>
#include <cstdio>
#include <vector>

#define endl '\n'

using namespace std;

int n, k, x, y;
bool gen=false;

vector<int> v1, v2;

void solve(int depth)
{
    if(gen) return;
    bool fl=true;
    for(int i=0; i<n; ++i)
    {
        if(v1[i]!=v2[i])
        {
            fl=false;
            break;
        }
    }
    if(fl)
    {
        gen=true;
        return;
    }
    if(depth==3) return;
    for(int i=0; i+2*k-1<n; ++i)
    {
        x=i;
        y=i+k;
        for(int z=0; z<k; ++z) swap(v1[x++], v1[y++]);
        solve(depth+1);
        x=i;
        y=i+k;
        for(int z=0; z<k; ++z) swap(v1[x++], v1[y++]);
    }
}

int main ()
{
    //freopen("i22.txt", "r", stdin);
    ios::sync_with_stdio(false);cin.tie(NULL);
    cin>>n>>k;
    for(int i=0; i<n; ++i)
    {
        cin>>x;
        v1.push_back(x);
    }
    for(int i=0; i<n; ++i)
    {
        cin>>x;
        v2.push_back(x);
    }
    solve(0);
    if(gen) cout<<"1\n";
    else cout<<"0\n";
    return 0;
}
