#include<iostream>
#include<cstring>
#include<vector>
using namespace std;
vector<int> v[105];
int n,m;
int mat[105][105];
int pred[105];
int ans;
void dfs (int pos)
{
    if (pos==n)
    {
        while (pred[pos]!=pos)
        {
            mat[pred[pos]][pos]--;
            mat[pos][pred[pos]]--;
            pos=pred[pos];
        }
        ans++;
        return;
    }
    for (int i=0; i<v[pos].size(); i++)
    {
        if(pred[v[pos][i]]==-1 && mat[v[pos][i]][pos]!=0)
        {
            pred[v[pos][i]]=pos;
            dfs(v[pos][i]);
            pred[v[pos][i]]=-1;
        }
    }
}
void solve ()
{
    for (int i=0; i<v[1].size(); i++)
    {
        if (mat[v[1][i]][1]==0)
            continue;
        memset(pred,-1,sizeof(pred));
        pred[1]=1;
        pred[v[1][i]]=1;
        dfs(v[1][i]);
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    for (int i=0; i<m; i++)
    {
        int x,y;
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
        mat[x][y]=mat[y][x]=1;
    }
    solve();
    cout<<ans<<'\n';
    int q;
    cin>>q;
    for (int i=0; i<q; i++)
    {
        int x,y;
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
        mat[x][y]++;
        mat[y][x]++;
        solve();
        cout<<ans<<'\n';
    }
}
