#include <bits/stdc++.h>
using namespace std;
const int MAX_N=100003;
int n, k, p[MAX_N], q[MAX_N], curr[MAX_N], toBe[MAX_N], tree[4*MAX_N];
vector<int> toReplaceFirst[MAX_N];
vector<int> toReplaceSecond[MAX_N];
void read()
{
    scanf("%d %d", &n, &k);
    for(int i=1; i<=n; i++)
        scanf("%d", &p[i]);
    for(int i=1; i<=n; i++)
        scanf("%d", &q[i]);
}
void updateFenwick(int index, int value)
{
    for(; index<=n; index+=index&(-index))
        tree[index]+=value;
}
int getSumFenwick(int index)
{
    int ans=0;
    for(; index; index-=index&(-index))
        ans+=tree[index];
    return ans;
}
int queryFenwick(int left, int right)
{
    return getSumFenwick(right)-getSumFenwick(left-1);
}
void possible()
{
    printf("1\n");
    exit(0);
}
void notPossible()
{
    printf("0\n");
    exit(0);
}
void precompute()
{
    for(int i=1; i<=k; i++)
    {
        toReplaceFirst[i].push_back(0);
        toReplaceSecond[i].push_back(0);
        for(int j=i; j<=n; j+=k)
        {
            toBe[q[j]]=toReplaceSecond[i].size();
            toReplaceFirst[i].push_back(p[j]);
            toReplaceSecond[i].push_back(q[j]);
            curr[p[j]]=i;
            if(curr[q[j]]!=i)
                notPossible();
        }
    }
}
int Try(int maxRange)
{
    for(int i=0; i<toReplaceFirst[maxRange].size(); i++)
        toReplaceFirst[maxRange][i]=curr[toReplaceFirst[maxRange][i]];
    int cnt=0;
    for(int i=1; i<toReplaceFirst[maxRange].size(); i++)
        for(int j=1; j<i; j++)
            cnt+=toReplaceFirst[maxRange][i]<toReplaceFirst[maxRange][j];
    return cnt%2==1;
}
void solve()
{
    int moves=0;
    for(int i=1; i<=k; i++)
        moves+=Try(i);
    printf("%d\n", moves%k==0);
}
int main()
{
    //freopen("input.txt", "r", stdin);
    read();
    precompute();
    solve();
    return 0;
}
