#include <bits/stdc++.h>
using namespace std;
const int MAX_N=103;
int n, m, q, ans[MAX_N][MAX_N], parent[MAX_N], target, source;
int used[MAX_N], maxFlow[MAX_N][MAX_N], maxFlow2[MAX_N][MAX_N];
vector<int> v[MAX_N];
void read()
{
    scanf("%d %d", &n, &m);
    source=1;
    target=n;
    int first, second;
    for(int i=1; i<=m; i++)
    {
        scanf("%d %d", &first, &second);
        v[first].push_back(second);
        v[second].push_back(first);
        maxFlow[first][second]=1;
        maxFlow[second][first]=1;
        maxFlow2[first][second]=1;
        maxFlow2[second][first]=1;
    }
}
void trace_back(int ver)
{
    if(ver==parent[ver])
        return;
    ans[parent[ver]][ver]++;
    maxFlow[ver][parent[ver]]++;
    maxFlow[parent[ver]][ver]--;
    trace_back(parent[ver]);
}
void BFS(int colour)
{
    queue<int> q;
    q.push(source);
    parent[source]=source;
    used[source]=colour;
    int curr;
    while(!q.empty())
    {
        curr=q.front();
        q.pop();
        for(int i=1; i<=n; i++)
            if(i!=curr&&used[i]!=colour&&ans[curr][i]+1<=maxFlow[curr][i])
            {
                parent[i]=curr;
                used[i]=colour;
                q.push(i);
            }
    }
}
void solve()
{
    for(int i=1; i<=n+1; i++)
    {
        BFS(i);
        if(used[n]!=i)
            break;
        trace_back(target);
    }
    long long int cnt=0;
    for(int i=1; i<=n; i++)
        cnt+=ans[i][target];
    printf("%lld\n", cnt);
}
void init()
{
    for(int i=1; i<=n+1; i++)
    {
        used[i]=0;
        parent[i]=0;
    }
    for(int i=1; i<=n; i++)
        for(int j=1; j<=n; j++)
        {
            ans[i][j]=0;
            maxFlow[i][j]=maxFlow2[i][j];
        }
}
void queries()
{
    scanf("%d", &q);
    int from, to;
    while(q--)
    {
        scanf("%d %d", &from, &to);
        maxFlow2[from][to]++;
        maxFlow2[to][from]++;
        init();
        solve();
    }
}
int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    read();
    solve();
    queries();
    return 0;
}
