#include <iostream>
using namespace std;

const int MAXN = 100005;

int n, k;
int p[MAXN], q[MAXN];

int pos[MAXN], cnt = 0;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> p[i];
    }
    for (int i = 1; i <= n; ++ i)
    {
        cin >> q[i];
        pos[q[i]] = i;
    }
}

int countinv(int l, int r)
{
    int cnt = 0;
    for (int i = l; i <= r; ++ i)
    {
        for (int j = i + 1; j <= r; ++ j)
        {
            if (pos[p[i]] > pos[p[j]]) cnt++;
        }
    }
    return cnt;
}

void doit(int idx)
{
    for (int i = idx; i <= idx + k - 1; ++ i)
    {
        swap(p[i], p[i + k]);
    }
}

bool check(int i)
{
    int inv1 = countinv(i, i + 2 * k - 1);
    doit(i);
    int inv2 = countinv(i, i + 2 * k - 1);

    // cout << inv1 << ' ' << inv2 << endl;

    if (inv1 > inv2 - 3)
    {
        cnt -= inv1 - inv2;
        return true;
    }
    else
    {
        doit(i);
        return false;
    }
}

int main()
{
    Init();
    cnt = countinv(1, n);

   // cout << cnt << endl;

    int i = 0;
    int clock = 1;
    while ( ++clock < 1000 )
    {
        if (i + 2 * k - 1 > n) i = 1;
        if (!check(i)) i++;
        //cout << cnt << endl;
    }

    if (cnt == 0) cout << 1 << endl;
    else cout << 0 << endl;
    return 0;
}

/*
6 2
5 6 1 2 3 4
3 6 5 2 1 4
*/

